#include "DiskMonitorEx.h"

CHAR szClassName[] = "SystrayDiskMonitorExClass";
HPOINTER hptrDiskIcon;

MRESULT EXPENTRY DiskMonitorWindowProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY DiskMonitorDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

HMODULE hmod;
HAB habMain;


/****************************************************************\
 * Initialization plugin                                        *
 *--------------------------------------------------------------*
 * HMODULE hSelf, // ਯ 㤠 
 * HAB     hab,   // 类
 * PWCLASS pwc,   // ᯨ᮪ ᮤঠ ᮢ  (.)
 * PUSHORT pus    // ᨬ쭮 ⢮ ਭ ᮢ
\****************************************************************/
BOOL EXPENTRY RegisterPluginProc(HMODULE hSelf, HAB hab,
                PWCLASS pwc, PUSHORT pus)
{
  hmod = hSelf;
  habMain = hab;
  *pus = 1;       // number of classes loaded in

  strcpy(pwc->szName, szClassName);
  pwc->ulCfgSize = sizeof(UNITDISKMON);
  pwc->ulSafeAlloc = sizeof(UNITDISKMON);
  pwc->bInitalUnitWidthPercent = 11;
  WinRegisterClass(hab, (PSZ)szClassName, (PFNWP)DiskMonitorWindowProc,
    CS_SIZEREDRAW, 8L);
  *pus = 1;
  return TRUE;
}


/****************************************************************\
 *  Disk Monitor Ext systray unit window procedure              *
 *--------------------------------------------------------------*
\****************************************************************/
MRESULT EXPENTRY DiskMonitorWindowProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  PUNITDISKMON punit;

  punit = (PUNITDISKMON)WinQueryWindowULong(hwnd, 0L);

  switch( msg ) {
    case WM_CREATE:
      punit = (PUNITDISKMON)mp1;

      WinSetWindowULong(hwnd, 0L, (ULONG)punit);

      if( !punit->bZero ) {
        punit->bZero = 1;
        memset(punit->chDrive, 0, sizeof(punit->chDrive));
        strcpy(punit->chDrive, "C");
        punit->currDrive = 0;
        punit->showIcon = TRUE;
        punit->showInfo = TRUE;
        punit->uppr.fgColor = 0L;
        punit->uppr.bgColor = 0x00CCCCCCL;
        strcpy(punit->uppr.szFont,"8.Helv");

        WinLoadString(habMain, hmod, IDMSG_HINT,
          sizeof(punit->unit.szBubble), (PSZ)punit->unit.szBubble);
        punit->unit.ulRefresh = 15L;
      }

      hptrDiskIcon = WinLoadPointer(HWND_DESKTOP, hmod, DLG_DISKMONITOREXT);

      SetUnitPresParam(hwnd, &punit->uppr);
      DrawUnitIconText(hwnd, hptrDiskIcon, punit);
      WinSendMsg(WinQueryWindow(hwnd, QW_PARENT), WM_USER, (MPARAM)hwnd,
        (MPARAM)punit->unit.szBubble);

      break;

    case WM_PAINT:
      DrawUnitIconText(hwnd, hptrDiskIcon, punit);
      return (MRESULT) NULL;

    case WM_USERTIMER:
      WinInvalidateRect(hwnd, NULL, FALSE);
      return (MRESULT) NULL;

/*
    case WM_CHORD:
    {
      if( strlen(punit->chDrive) > 1 ) {
        RECTL hwndRectl;
        //  ࠭ 
        WinQueryWindowRect(hwnd, &hwndRectl);
        WinSetWindowPos(hwnd, HWND_TOP, 0, 0,//hwndRectl.xLeft, hwndRectl.yBottom,
            hwndRectl.xRight - hwndRectl.xLeft,
            (hwndRectl.yTop - hwndRectl.yBottom) * strlen(punit->chDrive),
            SWP_SIZE | SWP_ZORDER);
//        ...
      }
      break;
    }
*/

    case WM_BUTTON1CLICK:
    {
      if( strlen(punit->chDrive) <= 1 ) break;
      if( SHORT2FROMMP(mp2) == KC_SHIFT ) punit->currDrive--;
      else punit->currDrive++;
      if( punit->currDrive >= strlen(punit->chDrive) ) punit->currDrive = 0;
      if( punit->currDrive < 0 ) punit->currDrive = strlen(punit->chDrive)-1;
      WinInvalidateRect(hwnd, NULL, FALSE);
      break;
    }

    case WM_BUTTON2CLICK:
    {
      POINTL ptl;
      HWND   hwndMenu;
      SHORT i;
      MENUITEM mi;
      char buf[1024];

      hwndMenu = WinLoadMenu(hwnd, hmod, MNU_USERPOPUP);
      WinQueryPointerPos(HWND_DESKTOP, &ptl);
//      WinMapWindowPoints(HWND_DESKTOP, hwnd, &ptl, 1);
      if( punit->showInfo && strlen(punit->chDrive) >= 1 ) {
        // add free space info for all disks to popup menu
        mi.iPosition = MIT_END;
        mi.afStyle = MIS_SEPARATOR;
        mi.afAttribute = 0;
        mi.id = 300;
        mi.hwndSubMenu = NULL;
        mi.hItem = 0;
        WinSendMsg(hwndMenu, MM_INSERTITEM, (MPARAM)&mi, (MPARAM)NULL);
        mi.id++;
        mi.afStyle = MIS_TEXT;
        for( i=0; i < strlen(punit->chDrive); i++, mi.id++ ) {
          CreateOutputString(punit, buf, i);
          WinSendMsg(hwndMenu, MM_INSERTITEM, (MPARAM)&mi, (MPARAM)buf);
        }
      }
      WinPopupMenu(HWND_DESKTOP, hwnd, hwndMenu, ptl.x, ptl.y, IDM_UNITSET,
        PU_HCONSTRAIN | PU_VCONSTRAIN | PU_MOUSEBUTTON1 | PU_KEYBOARD);
      break;
    }

/*
    case WM_BUTTON1DBLCLK:
    {
      HOBJECT hObject;
      BOOL fSuccess;
      CHAR openDrive[4];

      openDrive[0] = punit->chDrive[punit->currDrive];
      openDrive[1] = NULL;
      strcat(openDrive, ":\\");
      hObject = WinQueryObject(openDrive);
      if( hObject != NULLHANDLE ) {
        fSuccess = WinOpenObject(hObject, 0, TRUE);
      }
      break;
    }
*/

    case WM_SPCPPC:
      WinInvalidateRect(hwnd, NULL, FALSE);
      return (MRESULT) NULL;

    case WM_COMMAND:
      switch( SHORT1FROMMP(mp1) )       // Extract the command value
      {
        case IDM_OPENOBJ:
        {
          HOBJECT hObject;
          BOOL fSuccess;
          CHAR openDrive[4];
          //#define OPEN_DEFAULT       0

          openDrive[0] = punit->chDrive[punit->currDrive];
          openDrive[1] = NULL;
          strcat(openDrive, ":\\");
          hObject = WinQueryObject(openDrive);
          if( hObject != NULLHANDLE ) {
            fSuccess = WinOpenObject(hObject, 0, TRUE);
          }
          break;
        }
        case IDM_UNITSET:
        {
          if( WinDlgBox(HWND_DESKTOP, (HWND)hwnd, (PFNWP)DiskMonitorDlgProc,
                hmod, DLG_DISKMONITOREXT, (PVOID)punit) == DID_OK ) {
            punit->currDrive = 0;
            WinInvalidateRect(hwnd, NULL, FALSE);
            WinPostMsg(hwnd, WM_TIMER, (MPARAM)0L, (MPARAM)0L);
          }
          break;
        }
        case IDM_SYSTRAYSET:
          WinPostMsg(WinQueryWindow(hwnd, QW_PARENT), WM_COMMAND,
            (MPARAM)0x100, (MPARAM)NULL);
          break;
        case IDM_EXIT:
          WinPostMsg(WinQueryWindow(hwnd, QW_PARENT), WM_COMMAND,
            (MPARAM)0x102, (MPARAM)NULL);
          break;
      }
      return (MRESULT)NULL;

    case WM_DESTROY:
      if( hptrDiskIcon != NULLHANDLE ) WinDestroyPointer(hptrDiskIcon);
      DosFreeMem((PVOID)punit);
      break;
    default:
      break;
//      return WinDefWindowProc(hwnd, msg, mp1, mp2);
  }
  return WinDefWindowProc(hwnd, msg, mp1, mp2);
}


/****************************************************************\
 *  Disk Monitor Ext Dialog window procedure                    *
 *--------------------------------------------------------------*
\****************************************************************/
MRESULT EXPENTRY DiskMonitorDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
  static PUNITDISKMON punit;

  switch(msg) {
    case WM_INITDLG:

      punit = (PUNITDISKMON)mp2;

      if( hptrDiskIcon != NULLHANDLE ) {
        WinSendMsg(hwnd, WM_SETICON, (MPARAM)hptrDiskIcon, NULL);
        WinInvalidateRect(hwnd, NULL, TRUE);
      }

      // Set drives (entry field control)
      WinSendDlgItemMsg(hwnd, EF_DRIVES, EM_SETTEXTLIMIT,
        (MPARAM)(sizeof(punit->chDrive)-1), NULL);
      WinSetDlgItemText(hwnd, EF_DRIVES, (PSZ)&(punit->chDrive));

      // Set refresh time (spinbutton control)
      WinSetDlgItemText(hwnd, SPB_REFRESH, (PSZ)&(punit->chDrive));
      WinSendDlgItemMsg(hwnd, SPB_REFRESH, SPBM_SETCURRENTVALUE,
        MPFROMSHORT(punit->unit.ulRefresh), 0L);

      // Set Show icon (CheckBox control)
      WinSendDlgItemMsg(hwnd, CB_ICON, BM_SETCHECK,
        MPFROMSHORT(punit->showIcon), 0L );

      // Set disks info (CheckBox control)
      WinSendDlgItemMsg(hwnd, CB_POPUPINFO, BM_SETCHECK,
        MPFROMSHORT(punit->showInfo), 0L );

      // Set hint (entry field control)
      WinSendDlgItemMsg(hwnd, EF_HINT, EM_SETTEXTLIMIT,
        (MPARAM)(sizeof(punit->unit.szBubble)-1), NULL);
      WinSetDlgItemText(hwnd, EF_HINT, (PSZ)&(punit->unit.szBubble));

      break;

    case WM_COMMAND:
      if( SHORT1FROMMP(mp1) == DID_OK ) {
        // Read drives (entry field control)
        WinQueryDlgItemText(hwnd, EF_DRIVES, sizeof(punit->chDrive),
          punit->chDrive);
        strupr(punit->chDrive);

        // Read refresh time (spinbutton control)
        WinSendDlgItemMsg(hwnd, SPB_REFRESH, SPBM_QUERYVALUE,
          MPFROMLONG(&(punit->unit.ulRefresh)), 0L );

        // Read Show icon (CheckBox control)
        punit->showIcon = (BOOL)WinSendDlgItemMsg(hwnd, CB_ICON,
          BM_QUERYCHECK, (MPARAM)NULL, (MPARAM)NULL );

        // Read disks info (CheckBox control)
        punit->showInfo = (BOOL)WinSendDlgItemMsg(hwnd, CB_POPUPINFO,
          BM_QUERYCHECK, (MPARAM)NULL, (MPARAM)NULL );

        // Read hint (entry field control)
        WinQueryDlgItemText(hwnd, EF_HINT, sizeof(punit->unit.szBubble),
          punit->unit.szBubble);
      }
      WinDismissDlg(hwnd, SHORT1FROMMP(mp1));
      break;

    default:
      return WinDefDlgProc(hwnd, msg, mp1, mp2);
  }
  return (MRESULT)0;
}
