#include "DiskMonitorEx.h"


VOID GetUnitPresParam(HWND hwnd, UPPR *uppr)
{
  ULONG ulTemp, ulbg, ulfg;

  WinQueryPresParam(hwnd, PP_FONTNAMESIZE, NULL, &ulTemp, FACESIZE/*80*/, uppr->szFont, 0);
  WinQueryPresParam(hwnd, PP_BACKGROUNDCOLOR, NULL, &ulTemp, sizeof(LONG),
                    &ulbg, QPF_PURERGBCOLOR);
  WinQueryPresParam(hwnd, PP_FOREGROUNDCOLOR, NULL, &ulTemp, sizeof(LONG),
                    &ulfg, QPF_PURERGBCOLOR);
  if((ulbg==ulfg) && (ulbg==0L)) return;

  uppr->fgColor=ulfg;
  uppr->bgColor=ulbg;
}


VOID SetUnitPresParam(HWND hwnd,UPPR *uppr)
{
  WinSetPresParam(hwnd, PP_FONTNAMESIZE, FACESIZE/*80*/, uppr->szFont);
  WinSetPresParam(hwnd, PP_BACKGROUNDCOLOR, sizeof(LONG), &uppr->bgColor);
  WinSetPresParam(hwnd, PP_FOREGROUNDCOLOR, sizeof(LONG), &uppr->fgColor);
}


VOID CreateOutputString(PUNITDISKMON punit, char * buf, int i)
{
  FSALLOCATE level1;      // File-system device allocation
  char str[16];
  APIRET rc;

  rc = DosQueryFSInfo((ULONG)(punit->chDrive[i]-64), FSIL_ALLOC,
         (PVOID)&level1, sizeof(level1));
  sprintf(buf, "%c: ", punit->chDrive[i]);
  if( rc != NO_ERROR ) {
    if( rc == ERROR_INVALID_DRIVE ) strcpy(str, "invalid"); else // =15=
    if( rc == ERROR_NOT_READY ) strcpy(str, "not ready");        // =21=
    sprintf(buf+strlen(buf), "%s", str);
  }
  else {
    sprintf(buf+strlen(buf), "%luM Free",
      level1.cSectorUnit*level1.cUnitAvail/2048);
  }
}


VOID DrawUnitIconText(HWND hwnd, HPOINTER hIcon, PUNITDISKMON punit)
{
  HPS hps;
  RECTL rcl;
  char buf[124];

  CreateOutputString(punit, buf, punit->currDrive);
  GetUnitPresParam(hwnd, &punit->uppr);

  hps = WinBeginPaint(hwnd, NULL, NULL);
  GpiCreateLogColorTable(hps, 0L, LCOLF_RGB, 0L, 0L, (PLONG) NULL);
  WinQueryWindowRect(hwnd, &rcl);

  WinFillRect(hps, &rcl, punit->uppr.bgColor);
  WinDrawBorder(hps, &rcl, 1, 1, 0L, 0L, 0x800L);
  if( hIcon && punit->showIcon ) {
    DrawPointer(hps, 3, 3, (int)rcl.yTop - 7, (int)rcl.yTop - 7, hIcon,
      punit->uppr.bgColor);
    rcl.xLeft += rcl.yTop - 5;
  }
  WinDrawText(hps, -1, buf, &rcl, punit->uppr.fgColor,
    punit->uppr.bgColor, DT_CENTER | DT_VCENTER);

  WinEndPaint(hps);
}


VOID DrawPointer(HPS hps, int x, int y, int sx, int sy,
                 HPOINTER hptr, LONG bgColor)
{
  POINTL pt[4];
  RECTL  rc1,rc2;
  POINTERINFO pim;
  BITMAPINFOHEADER2 bmp;

  WinQueryPointerInfo(hptr, &pim);

  rc2.xLeft = x;
  rc2.xRight = x+sx+1;
  rc2.yBottom = y;
  rc2.yTop = y+sy+1;

  pt[0].x = x;
  pt[0].y = y;
  pt[1].x = x+sx;
  pt[1].y = y+sy;

  GpiSetPattern(hps, PATSYM_SOLID);
  GpiSetColor(hps, CLR_BLACK);
  GpiSetBackColor(hps, bgColor);
//GpiSetMix(hps, FM_OVERPAINT);
//GpiSetBackMix(hps, BM_OVERPAINT);

  if( (pim.hbmMiniColor) && (sx<20) ) {     // mini-sized color sub-bitmap
    bmp.cbFix = 16L;
    GpiQueryBitmapInfoHeader(pim.hbmMiniColor, &bmp);
    rc1.xLeft = 0;
    rc1.xRight = bmp.cx;
    rc1.yBottom = bmp.cy;
    rc1.yTop = bmp.cy*2;
    // first part: clear bg mask for icon
    WinDrawBitmap(hps, pim.hbmMiniPointer, &rc1, (PPOINTL)&rc2,
      bgColor, CLR_BLACK, DBM_STRETCH);
    pt[2].x = pt[2].y = 0;
    pt[3].x = bmp.cx;
    pt[3].y = bmp.cy;
    // second part: draw color bits
    GpiWCBitBlt(hps, pim.hbmMiniColor, 4, pt, ROP_SRCPAINT, BBO_IGNORE);
  }
  else if( pim.hbmColor ) {   // normal-sized color sub-bitmap
    bmp.cbFix = 16L;
    GpiQueryBitmapInfoHeader(pim.hbmColor, &bmp);
    rc1.xLeft = 0;
    rc1.xRight = bmp.cx;
    rc1.yBottom = bmp.cy;
    rc1.yTop = bmp.cy*2;
    WinDrawBitmap(hps, pim.hbmPointer, &rc1, (PPOINTL)&rc2,
      bgColor, CLR_BLACK, DBM_STRETCH);
    pt[2].x = pt[2].y = 0;
    pt[3].x = bmp.cx;
    pt[3].y = bmp.cy;
    GpiWCBitBlt(hps, pim.hbmColor, 4, pt, ROP_SRCPAINT,BBO_IGNORE);
  } else {          // b/w sub-bitmap
    bmp.cbFix = 16L;
    GpiQueryBitmapInfoHeader(pim.hbmPointer, &bmp);
    rc1.xLeft = 0; rc1.xRight = bmp.cx;
    rc1.yBottom = bmp.cy; rc1.yTop = bmp.cy*2;
    WinDrawBitmap(hps, pim.hbmPointer, &rc1, (PPOINTL)&rc2,
      bgColor, CLR_BLACK, DBM_STRETCH);
    pt[2].x = pt[2].y = 0;
    pt[3].x = bmp.cx;
    pt[3].y = bmp.cy;
    GpiWCBitBlt(hps, pim.hbmPointer, 4, pt, ROP_SRCPAINT, BBO_IGNORE);
  }
}
